=== debian/changelog ===
ros-galactic-rcl (3.1.4-1focal) focal; urgency=high

  * Fix buffer overflow in argument parsing caused by lexer returning length beyond length of string (#980 <https://github.com/ros2/rcl/issues/980>)
  * Contributors: Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 02 Dec 2022 08:00:00 -0000

ros-galactic-rcl (3.1.3-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 28 Apr 2022 07:00:00 -0000

ros-galactic-rcl (3.1.2-1focal) focal; urgency=high

  * Fix up test_network_flow_endpoints. (#912 <https://github.com/ros2/rcl/issues/912>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Apr 2021 07:00:00 -0000

ros-galactic-rcl (3.1.1-1focal) focal; urgency=high

  * Make test_two_timers_ready_before_timeout less flaky (#911 <https://github.com/ros2/rcl/issues/911>)
  * Add publishing instrumentation (#905 <https://github.com/ros2/rcl/issues/905>)
  * Contributors: Christophe Bedard, Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-rcl (3.1.0-1focal) focal; urgency=high

  * Unique network flows (#880 <https://github.com/ros2/rcl/issues/880>)
  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#909 <https://github.com/ros2/rcl/issues/909>)
  * Add functions for waiting for publishers and subscribers (#907 <https://github.com/ros2/rcl/issues/907>)
  * Revert "Mark cyclonedds test_service test as flakey (#648 <https://github.com/ros2/rcl/issues/648>)" (#904 <https://github.com/ros2/rcl/issues/904>)
  * Guard against returning NULL or empty node names (#570 <https://github.com/ros2/rcl/issues/570>)
  * Contributors: Ananya Muddukrishna, Jacob Perron, Michel Hidalgo, shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-rcl (3.0.1-1focal) focal; urgency=high

  * Remove exceptions for rmw_connext_cpp tests. (#903 <https://github.com/ros2/rcl/issues/903>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 07:00:00 -0000

ros-galactic-rcl (3.0.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 07:00:00 -0000

ros-galactic-rcl (2.6.0-1focal) focal; urgency=high

  * Add support for rmw_connextdds (#895 <https://github.com/ros2/rcl/issues/895>)
  * Put an argument list of 'void' where no arguments are expected. (#899 <https://github.com/ros2/rcl/issues/899>)
  * Cleanup documentation for doxygen. (#896 <https://github.com/ros2/rcl/issues/896>)
  * Contributors: Andrea Sorbini, Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Mar 2021 07:00:00 -0000

ros-galactic-rcl (2.5.2-1focal) focal; urgency=high

  * Reference test resources directly from source tree (#554 <https://github.com/ros2/rcl/issues/554>)
  * Contributors: Scott K Logan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 05 Feb 2021 08:00:00 -0000

ros-galactic-rcl (2.5.1-1focal) focal; urgency=high

  * Re-add "Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)" (#884 <https://github.com/ros2/rcl/issues/884>)
  * Revert "Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)" (#883 <https://github.com/ros2/rcl/issues/883>)
  * Move the guard condition cleanup after removing callback. (#877 <https://github.com/ros2/rcl/issues/877>)
  * Make test_subscription_nominal_string_sequence more reliable (#881 <https://github.com/ros2/rcl/issues/881>)
  * Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)
  * Add NULL check in remap.c (#879 <https://github.com/ros2/rcl/issues/879>)
  * Contributors: Barry Xu, Chris Lalancette, Ivan Santiago Paunovic, Nikolai Morin

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rcl (2.5.0-1focal) focal; urgency=high

  * Add const to constant rcl_context functions (#872 <https://github.com/ros2/rcl/issues/872>)
  * Fix another failing test on CentOS 7 (#863 <https://github.com/ros2/rcl/issues/863>)
  * Update QDs to QL 1 (#866 <https://github.com/ros2/rcl/issues/866>)
  * Address clang static analysis issues (#865 <https://github.com/ros2/rcl/issues/865>)
  * Fix flaky test_info_by_topic (#859 <https://github.com/ros2/rcl/issues/859>)
  * Update QL (#858 <https://github.com/ros2/rcl/issues/858>)
  * Refactor for removing unnecessary source code (#857 <https://github.com/ros2/rcl/issues/857>)
  * Clarify storing of current_time (#850 <https://github.com/ros2/rcl/issues/850>)
  * Make tests in test_graph.cpp more reliable (#854 <https://github.com/ros2/rcl/issues/854>)
  * Fix for external log segfault after SIGINT (#844 <https://github.com/ros2/rcl/issues/844>)
  * Update tracetools QL and add to rcl_lifecycle's QD (#845 <https://github.com/ros2/rcl/issues/845>)
  * Make test logging rosout more reliable (#846 <https://github.com/ros2/rcl/issues/846>)
  * Return OK when finalizing zero-initialized contexts (#842 <https://github.com/ros2/rcl/issues/842>)
  * Zero initialize events an size_of_events members of rcl_wait_set_t (#841 <https://github.com/ros2/rcl/issues/841>)
  * Update deprecated gtest macros (#818 <https://github.com/ros2/rcl/issues/818>)
  * Contributors: Alejandro Hernández Cordero, Audrow Nash, Chen Lihui, Chris Lalancette, Christophe Bedard, Ivan Santiago Paunovic, Jacob Perron, Stephen Brawner, Thijs Raymakers, tomoya

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 08 Dec 2020 08:00:00 -0000

ros-galactic-rcl (2.4.0-1focal) focal; urgency=high

  * Make sure to check the return value of rcl APIs. (#838 <https://github.com/ros2/rcl/issues/838>)
  * Add convenient node method to get a final topic/service name (#835 <https://github.com/ros2/rcl/issues/835>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic


